diff -uNr fwbuilder-2.1.8/src/gui/findobjectwidget_q.ui fwbuilder-2.1.9/src/gui/findobjectwidget_q.ui
--- fwbuilder-2.1.8/src/gui/findobjectwidget_q.ui	2006-11-21 03:40:49.000000000 +0100
+++ fwbuilder-2.1.9/src/gui/findobjectwidget_q.ui	2007-02-11 04:37:36.000000000 +0100
@@ -272,29 +272,9 @@
                 <property name="name">
                     <cstring>unnamed</cstring>
                 </property>
-                <widget class="FWObjectDropArea" row="0" column="1" rowspan="2" colspan="1">
-                    <property name="name">
-                        <cstring>findDropArea</cstring>
-                    </property>
-                    <property name="sizePolicy">
-                        <sizepolicy>
-                            <hsizetype>0</hsizetype>
-                            <vsizetype>0</vsizetype>
-                            <horstretch>0</horstretch>
-                            <verstretch>0</verstretch>
-                        </sizepolicy>
-                    </property>
-                    <property name="minimumSize">
-                        <size>
-                            <width>100</width>
-                            <height>80</height>
-                        </size>
-                    </property>
-                    <property name="font">
-                        <font>
-                        </font>
-                    </property>
-                </widget>
+                <property name="spacing">
+                    <number>2</number>
+                </property>
                 <widget class="QComboBox" row="1" column="0">
                     <property name="name">
                         <cstring>findAttr</cstring>
@@ -341,7 +321,47 @@
                         </font>
                     </property>
                 </widget>
-                <widget class="QCheckBox" row="2" column="0" rowspan="1" colspan="2">
+                <widget class="FWObjectDropArea" row="0" column="2" rowspan="2" colspan="1">
+                    <property name="name">
+                        <cstring>findDropArea</cstring>
+                    </property>
+                    <property name="sizePolicy">
+                        <sizepolicy>
+                            <hsizetype>0</hsizetype>
+                            <vsizetype>0</vsizetype>
+                            <horstretch>0</horstretch>
+                            <verstretch>0</verstretch>
+                        </sizepolicy>
+                    </property>
+                    <property name="minimumSize">
+                        <size>
+                            <width>100</width>
+                            <height>80</height>
+                        </size>
+                    </property>
+                    <property name="font">
+                        <font>
+                        </font>
+                    </property>
+                </widget>
+                <spacer row="0" column="1">
+                    <property name="name">
+                        <cstring>spacer5</cstring>
+                    </property>
+                    <property name="orientation">
+                        <enum>Horizontal</enum>
+                    </property>
+                    <property name="sizeType">
+                        <enum>Fixed</enum>
+                    </property>
+                    <property name="sizeHint">
+                        <size>
+                            <width>20</width>
+                            <height>20</height>
+                        </size>
+                    </property>
+                </spacer>
+                <widget class="QCheckBox" row="2" column="0" rowspan="1" colspan="3">
                     <property name="name">
                         <cstring>useRegexp</cstring>
                     </property>
diff -uNr fwbuilder-2.1.8/src/gui/FWBMainWindow_q.ui fwbuilder-2.1.9/src/gui/FWBMainWindow_q.ui
--- fwbuilder-2.1.8/src/gui/FWBMainWindow_q.ui	2006-08-21 17:34:53.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/FWBMainWindow_q.ui	2007-02-04 04:58:59.000000000 +0100
@@ -53,6 +53,14 @@
             <property name="name">
                 <cstring>frame13</cstring>
             </property>
+            <property name="sizePolicy">
+                <sizepolicy>
+                    <hsizetype>3</hsizetype>
+                    <vsizetype>5</vsizetype>
+                    <horstretch>0</horstretch>
+                    <verstretch>0</verstretch>
+                </sizepolicy>
+            </property>
             <property name="frameShape">
                 <enum>StyledPanel</enum>
             </property>
@@ -249,6 +257,14 @@
                         <property name="name">
                             <cstring>rightFrame</cstring>
                         </property>
+                        <property name="sizePolicy">
+                            <sizepolicy>
+                                <hsizetype>0</hsizetype>
+                                <vsizetype>5</vsizetype>
+                                <horstretch>0</horstretch>
+                                <verstretch>0</verstretch>
+                            </sizepolicy>
+                        </property>
                         <property name="frameShape">
                             <enum>NoFrame</enum>
                         </property>
@@ -493,7 +509,7 @@
                                                 </property>
                                                 <property name="sizePolicy">
                                                     <sizepolicy>
-                                                        <hsizetype>1</hsizetype>
+                                                        <hsizetype>0</hsizetype>
                                                         <vsizetype>0</vsizetype>
                                                         <horstretch>0</horstretch>
                                                         <verstretch>0</verstretch>
@@ -501,7 +517,7 @@
                                                 </property>
                                                 <property name="minimumSize">
                                                     <size>
-                                                        <width>50</width>
+                                                        <width>0</width>
                                                         <height>0</height>
                                                     </size>
                                                 </property>
@@ -515,7 +531,7 @@
                                                 </property>
                                                 <property name="sizePolicy">
                                                     <sizepolicy>
-                                                        <hsizetype>1</hsizetype>
+                                                        <hsizetype>0</hsizetype>
                                                         <vsizetype>0</vsizetype>
                                                         <horstretch>0</horstretch>
                                                         <verstretch>0</verstretch>
@@ -630,6 +646,7 @@
         <action name="installAction"/>
     </item>
     <item text="Tools" name="Tools">
+        <action name="fileCompareAction"/>
         <action name="DiscoveryDruidAction"/>
     </item>
     <item text="&amp;Help" name="helpMenu">
@@ -1304,7 +1321,7 @@
             <string>Commit</string>
         </property>
         <property name="menuText">
-            <string>C&amp;ommit</string>
+            <string>Co&amp;mmit</string>
         </property>
         <property name="statusTip">
             <string>Commit Opened File to RCS and Continue Editing</string>
@@ -1354,6 +1371,17 @@
             <string>new item</string>
         </property>
     </action>
+    <action>
+        <property name="name">
+            <cstring>fileCompareAction</cstring>
+        </property>
+        <property name="text">
+            <string>Find Conflicting Objects in Two Files</string>
+        </property>
+        <property name="menuText">
+            <string>Find Conflicting Objects in Two Files</string>
+        </property>
+    </action>
 </actions>
 <connections>
     <connection>
@@ -1609,6 +1637,12 @@
         <slot>removeRule()</slot>
     </connection>
     <connection>
+        <sender>ruleSets</sender>
+        <signal>currentChanged(QWidget*)</signal>
+        <receiver>FWBMainWindow_q</receiver>
+        <slot>ruleSetTabChanged(QWidget*)</slot>
+    </connection>
+    <connection>
         <sender>toolbarFileNew</sender>
         <signal>activated()</signal>
         <receiver>FWBMainWindow_q</receiver>
@@ -1627,10 +1661,10 @@
         <slot>fileSave()</slot>
     </connection>
     <connection>
-        <sender>ruleSets</sender>
-        <signal>currentChanged(QWidget*)</signal>
+        <sender>fileCompareAction</sender>
+        <signal>activated()</signal>
         <receiver>FWBMainWindow_q</receiver>
-        <slot>ruleSetTabChanged(QWidget*)</slot>
+        <slot>fileCompare()</slot>
     </connection>
 </connections>
 <includes>
@@ -1687,6 +1721,7 @@
     <slot>showNextSearchResult()</slot>
     <slot>closeAuxiliaryPanel()</slot>
     <slot>ruleSetTabChanged(QWidget*)</slot>
+    <slot>fileCompare()</slot>
 </slots>
 <functions>
     <function access="private" specifier="non virtual">init()</function>
diff -uNr fwbuilder-2.1.8/src/gui/FWBMainWindow_q.ui.h fwbuilder-2.1.9/src/gui/FWBMainWindow_q.ui.h
--- fwbuilder-2.1.8/src/gui/FWBMainWindow_q.ui.h	2006-06-08 08:00:43.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/FWBMainWindow_q.ui.h	2007-02-04 04:58:59.000000000 +0100
@@ -310,4 +310,9 @@
 void FWBMainWindow_q::ruleSetTabChanged(QWidget*)
 {
 
+}
+
+void FWBMainWindow_q::fileCompare()
+{
+
 }
\ Kein Zeilenumbruch am Dateiende.
diff -uNr fwbuilder-2.1.8/src/gui/FWObjectPropertiesFactory.cpp fwbuilder-2.1.9/src/gui/FWObjectPropertiesFactory.cpp
--- fwbuilder-2.1.8/src/gui/FWObjectPropertiesFactory.cpp	2006-10-24 05:43:25.000000000 +0200
+++ fwbuilder-2.1.9/src/gui/FWObjectPropertiesFactory.cpp	2007-02-04 04:58:59.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@fwbuilder.org
 
-  $Id: FWObjectPropertiesFactory.cpp,v 1.50 2006/10/24 03:43:25 vkurland Exp $
+  $Id: FWObjectPropertiesFactory.cpp,v 1.51 2007/02/04 03:58:59 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -31,6 +31,7 @@
 #include <qobject.h>
 #include <qtextstream.h>
 #include <qdatetime.h>
+#include <qregexp.h>
 
 #include "FWObjectPropertiesFactory.h"
 #include "platforms.h"
@@ -203,11 +204,28 @@
 }
 
 
+QString FWObjectPropertiesFactory::stripHTML(const QString &str)
+{
+    // note that str may contain multiple lines
+    // separated by <br> and/or '\n'
+
+    QRegExp htmltag1 = QRegExp("<[^>]+>");
+    QRegExp htmltag2 = QRegExp("</[^>]+>");
+    QRegExp htmltd   = QRegExp("</td><td>");
+
+    QString res = str;
+    res = res.replace(htmltd,": ");
+    res = res.remove(htmltag1);
+    res = res.remove(htmltag2);
+    return res;
+}
+
 
 QString FWObjectPropertiesFactory::getObjectPropertiesDetailed(FWObject *obj,
                                                                bool showPath,
                                                                bool tooltip,
-                                                               bool accentName)
+                                                               bool accentName,
+                                                               bool richText)
 {
     QString str;
 
@@ -240,18 +258,18 @@
 
         if (IPv4::isA(obj))
         {
-            if (showPath && !tooltip) str += path + "<br>\n";
+            if (showPath && !tooltip) str += "<b>Path: </b>" + path + "<br>\n";
             str +=  Address::cast(obj)->getAddress().toString().c_str();
             str += "/";
             str += Address::cast(obj)->getNetmask().toString().c_str();
 
         } else if (physAddress::isA(obj))
         {
-            if (showPath && !tooltip) str += path + "<br>\n";
+            if (showPath && !tooltip) str += "<b>Path: </b>" + path + "<br>\n";
             str += physAddress::cast(obj)->getPhysAddress().c_str();
         } else if (DNSName::isA(obj))
         {
-            if (showPath && !tooltip) str += path + "<br>\n";
+            if (showPath && !tooltip) str += "<b>Path: </b>" + path + "<br>\n";
             str += QObject::tr("<b>DNS record:</b>");
             str += MultiAddress::cast(obj)->getSourceName().c_str();
             str += "<br>\n";
@@ -259,7 +277,7 @@
 
         } else if (AddressTable::isA(obj))
         {
-            if (showPath && !tooltip) str += path + "<br>\n";
+            if (showPath && !tooltip) str += "<b>Path: </b>" + path + "<br>\n";
             str += QObject::tr("<b>Table file:</b>");
             str += MultiAddress::cast(obj)->getSourceName().c_str();
             str += "<br>\n";
@@ -267,14 +285,14 @@
             
         } else if (AddressRange::isA(obj))
         {
-            if (showPath && !tooltip) str += path + "<br>\n";
+            if (showPath && !tooltip) str += "<b>Path: </b>" + path + "<br>\n";
             AddressRange *ar=AddressRange::cast(obj);
             str += ar->getRangeStart().toString().c_str();
             str += " - ";
             str += ar->getRangeEnd().toString().c_str();
         } else if (Host::isA(obj))
         {
-            if (showPath && !tooltip) str += path + "<br>\n";
+            if (showPath && !tooltip) str += "<b>Path: </b>" + path + "<br>\n";
 
             str +=  Address::cast(obj)->getAddress().toString().c_str() ;
 
@@ -288,7 +306,7 @@
 
         } else if (Network::isA(obj))
         {
-            if (showPath && !tooltip) str += path + "<br>\n";
+            if (showPath && !tooltip) str += "<b>Path: </b>" + path + "<br>\n";
             Network *n=Network::cast(obj);
             str += n->getAddress().toString().c_str();
             str += "/";
@@ -296,7 +314,7 @@
 
         } else if (Group::cast(obj)!=NULL)   // just any group
         {
-            if (showPath && !tooltip) str += path + "<br>\n";
+            if (showPath && !tooltip) str += "<b>Path: </b>" + path + "<br>\n";
             Group *g=Group::cast(obj);
             str += QObject::tr("%1 objects<br>\n").arg(g->size());
             int n = 0;
@@ -344,7 +362,7 @@
             
                
 
-            if (showPath && !tooltip) str += path + "<br>\n";
+            if (showPath && !tooltip) str += "<b>Path: </b>" + path + "<br>\n";
             str += "<table cellspacing=\"0\" cellpadding=\"0\">";
             str += QString("<tr><td>Platform:</td><td>") +
                 platform + "</td></tr>\n";
@@ -382,7 +400,7 @@
             
             if (q!="") str += " (" + q + ")";
             str += "<br>\n";
-            if (showPath && !tooltip) str += path + "<br>\n";
+            if (showPath && !tooltip) str += "<b>Path: </b>" + path + "<br>\n";
 
             physAddress *paddr=(Interface::cast(obj))->getPhysicalAddress();
             if (paddr!=NULL) 
@@ -395,7 +413,7 @@
         } else if (CustomService::isA(obj))
         {
 
-            if (showPath && !tooltip) str += path + "<br>\n";
+            if (showPath && !tooltip) str += "<b>Path: </b>" + path + "<br>\n";
 
             CustomService *s = dynamic_cast<CustomService*>(obj);
             bool first=true;
@@ -419,12 +437,12 @@
 
         } else if (IPService::isA(obj))
         {
-            if (showPath && !tooltip) str += path + "<br>\n";
+            if (showPath && !tooltip) str += "<b>Path: </b>" + path + "<br>\n";
             str += QObject::tr("protocol ") + obj->getStr("protocol_num").c_str();
 
         } else if (ICMPService::isA(obj))
         {
-            if (showPath && !tooltip) str += path + "<br>\n";
+            if (showPath && !tooltip) str += "<b>Path: </b>" + path + "<br>\n";
             str += QObject::tr("type: ") + obj->getStr("type").c_str()
                 + "  "
                 + QObject::tr("code: ") + obj->getStr("code").c_str();
@@ -438,11 +456,11 @@
             dps=obj->getInt("dst_range_start");
             dpe=obj->getInt("dst_range_end");
 
-            if (showPath && !tooltip) str += path + "<br>\n";
+            if (showPath && !tooltip) str += "<b>Path: </b>" + path + "<br>\n";
             str += "<table cellspacing=\"0\" cellpadding=\"0\">";
-            str += QString("<tr><td>source port range</td><td>%1:%2</td></tr>")
+            str += QString("<tr><td>source port range</td><td>%1:%2</td></tr>\n")
                 .arg(sps).arg(spe);
-            str += QString("<tr><td>destination port range</td><td>%1:%2</td></tr>")
+            str += QString("<tr><td>destination port range</td><td>%1:%2</td></tr>\n")
                 .arg(dps).arg(dpe);
             str += "</table>";
         } else if (TagService::isA(obj)) 
@@ -457,7 +475,9 @@
         cerr << ex.toString() << endl;
     }
 
-    return str;
+    if (richText) return str;
+
+    return FWObjectPropertiesFactory::stripHTML(str);
 }
 
 /*
diff -uNr fwbuilder-2.1.8/src/gui/FWObjectPropertiesFactory.h fwbuilder-2.1.9/src/gui/FWObjectPropertiesFactory.h
--- fwbuilder-2.1.8/src/gui/FWObjectPropertiesFactory.h	2006-02-19 08:49:48.000000000 +0100
+++ fwbuilder-2.1.9/src/gui/FWObjectPropertiesFactory.h	2007-02-04 04:58:59.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@fwbuilder.org
 
-  $Id: FWObjectPropertiesFactory.h,v 1.9 2006/02/19 07:49:48 vkurland Exp $
+  $Id: FWObjectPropertiesFactory.h,v 1.10 2007/02/04 03:58:59 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -47,11 +47,15 @@
     static QString getObjectPropertiesDetailed(libfwbuilder::FWObject *obj,
                                                bool showPath=false,
                                                bool tooltip=false,
-                                               bool accentName=true);
+                                               bool accentName=true,
+                                               bool richText=true);
     static QString getRuleActionProperties(libfwbuilder::PolicyRule *rule); 
     static QString getRuleActionPropertiesRich(libfwbuilder::PolicyRule *rule); 
     static QString getPolicyRuleOptions(libfwbuilder::Rule *rule);
     static QString getNATRuleOptions(libfwbuilder::Rule *rule);
+
+    static QString stripHTML(const QString &str);
+
 };
 
 #endif
diff -uNr fwbuilder-2.1.8/src/gui/FWWindow.cpp fwbuilder-2.1.9/src/gui/FWWindow.cpp
--- fwbuilder-2.1.8/src/gui/FWWindow.cpp	2006-11-10 06:24:48.000000000 +0100
+++ fwbuilder-2.1.9/src/gui/FWWindow.cpp	2007-02-04 04:58:59.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@fwbuilder.org
 
-  $Id: FWWindow.cpp,v 1.212 2006/11/10 05:24:48 vkurland Exp $
+  $Id: FWWindow.cpp,v 1.215 2007/02/04 03:58:59 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -143,6 +143,7 @@
 #include <qwidgetstack.h>
 #include <qlistbox.h>
 #include <qeventloop.h>
+#include <qtextstream.h>
 
 using namespace libfwbuilder;
 using namespace std;
@@ -393,10 +394,9 @@
     return true;
 }
 
-QString FWWindow::chooseNewFileName(const QString &fname,
-                                    bool checkPresence,const QString &title)
+QString FWWindow::getDestDir(const QString &fname)
 {
-    QString destdir;
+    QString destdir = "";
 
     if (st->getWDir().isEmpty())
     {
@@ -414,12 +414,22 @@
         } else
         {
             if (QFileInfo(fname).isDir()) destdir=fname;
-            else                      destdir = fname.left( fname.findRev('/',-1) );
+            else
+                destdir = fname.left( fname.findRev('/',-1) );
         }
     } else
     {
         destdir=st->getWDir();
     }
+    return destdir;
+}
+
+
+
+QString FWWindow::chooseNewFileName(const QString &fname,
+                                    bool checkPresence,const QString &title)
+{
+    QString destdir = getDestDir(fname);
 
     QString fn = QFileDialog::getSaveFileName( destdir,
        tr( "FWB Files (*.fwb);;All Files (*)" ),
@@ -1315,6 +1325,7 @@
         FWObject *dobj = ndb->findInIndex(FWObjectDatabase::getDeletedObjectsId());
         if (dobj) ndb->remove(dobj, false);
 
+#if 0
         list<FWObject*> newLibs;
         newLibs= ndb->getByType(Library::TYPENAME);
 
@@ -1349,7 +1360,7 @@
             for (list<FWObject*>::iterator i=duplicateLibs.begin(); i!=duplicateLibs.end(); i++)
                 ndb->remove(*i,false);
         }
-
+#endif
         MergeConflictRes mcr(this);
         db()->merge(ndb, &mcr);
 
@@ -1385,6 +1396,154 @@
 //    addOnLibs->add( fname.latin1() );
 }
 
+
+void FWWindow::fileCompare()
+{
+    fd->reset();   // fd : find dialog
+
+    QMessageBox initial_question( "Firewall Builder",
+                    tr("This operation inspects two data files (either .fwb or .fwl) and finds conflicting objects. Conflicting objects have the same internal ID but different attributes. Two data files can not be merged, or one imported into another, if they contain such objects. This operation also helps identify changes made to objects in two copies of the same data file.<br><br>This operation does not find objects present in one file but not in the other, such objects present no problem for merge or import operations.<br><br>This operation works with two external files, neither of which needs to be opened in the program. Currently opened data file is not affected by this operation and objects in the tree do not change.<br><br>Do you want to proceed ?"),
+                    QMessageBox::Information,
+                    QMessageBox::Yes | QMessageBox::Default,
+                    QMessageBox::No,
+                    QMessageBox::Escape );
+
+    initial_question.setTextFormat( Qt::RichText );
+    if (initial_question.exec() != QMessageBox::Yes) return;
+
+
+    QString fname1 = QFileDialog::getOpenFileName( st->getWDir(), 
+       "Firewall Builder 2 files (*.fwb);;FWB Library Files (*.fwl);;All Files (*)",
+                          this, 0,
+                          tr("Choose the first file") );
+
+    if (fname1.isEmpty()) return;   // Cancel
+
+    QString fname2 = QFileDialog::getOpenFileName( st->getWDir(), 
+       "Firewall Builder 2 files (*.fwb);;FWB Library Files (*.fwl);;All Files (*)",
+                          this, 0,
+                          tr("Choose the second file") );
+
+    if (fname2.isEmpty()) return;   // Cancel
+
+    MessageBoxUpgradePredicate upgrade_predicate;
+
+    FWObjectDatabase *db1;
+    FWObjectDatabase *db2;
+    FWObject *dobj;
+
+    try
+    {
+        db1 = new FWObjectDatabase();
+        db1->load(fname1,  &upgrade_predicate,  librespath);
+
+        dobj = db1->findInIndex(FWObjectDatabase::getDeletedObjectsId());
+        if (dobj) db1->remove(dobj, false);
+    } catch(FWException &ex)
+    {
+        QMessageBox::warning(
+            this,"Firewall Builder", 
+            tr("Error loading file %1:\n%2").
+                 arg(fname1).arg(ex.toString().c_str()),
+            tr("&Continue"), QString::null,QString::null,
+            0, 1 );
+        return;
+    }
+
+    try
+    {
+        db2 = new FWObjectDatabase();
+        db2->load(fname2,  &upgrade_predicate,  librespath);
+
+        dobj = db2->findInIndex(FWObjectDatabase::getDeletedObjectsId());
+        if (dobj) db2->remove(dobj, false);
+    } catch(FWException &ex)
+    {
+        QMessageBox::warning(
+            this,"Firewall Builder", 
+            tr("Error loading file %1:\n%2").
+                 arg(fname2).arg(ex.toString().c_str()),
+            tr("&Continue"), QString::null,QString::null,
+            0, 1 );
+        return;
+    }
+
+    try
+    {
+        // CompareObjectsDialog is just like ObjConflictResolutionDialog
+        // except it always returns 'accepted' and keeps record
+        // of all object differences so we can print report in the end
+
+        CompareObjectsDialog cod(this);
+        db1->merge(db2, &cod);
+        list<QString> report = cod.getReport();
+
+        delete db1;
+        delete db2;
+
+        ostringstream str;
+        str << cod.getNumberOfConflicts();
+
+        QMessageBox mb( "Firewall Builder",
+                        tr("Total number of conflicting objects: %1.\nDo you want to generate report?").arg(str.str()),
+                        QMessageBox::Information,
+                        QMessageBox::Yes | QMessageBox::Default,
+                        QMessageBox::No,
+                        QMessageBox::Escape );
+
+        if (mb.exec()== QMessageBox::Yes)
+        {
+            // save report to a file
+
+            QString destdir = getDestDir(fname1);
+
+            QString fn = QFileDialog::getSaveFileName( destdir,
+                           tr( "TXT Files (*.txt);;All Files (*)" ),
+                           this, 0,
+                           tr("Choose name and location for the report file"));
+
+            if (fwbdebug)
+                qDebug( QString("Saving report to %1").arg(fn) );
+
+            if (fn.isEmpty() ) return ;   // Cancel
+
+            if (fn.findRev(".txt",-1,false)==-1)
+            {
+                fn+=".txt";
+            }
+
+            QFile report_file(fn);
+            if (report_file.open(IO_WriteOnly))
+            {
+                QTextStream report_stream(&report_file);
+                for (list<QString>::iterator i=report.begin(); i!=report.end(); ++i)
+                {
+                    report_stream << *i;
+                }
+                report_file.close();
+            } else 
+            {
+                QMessageBox::critical(
+                    this,"Firewall Builder", 
+                    tr("Can not open report file for writing. File '%1'").arg(fn),
+                    tr("&Continue"), QString::null,QString::null,
+                    0, 1 );
+            }
+            
+        }
+
+    } catch(FWException &ex)
+    {
+        QMessageBox::warning(
+            this,"Firewall Builder", 
+            tr("Unexpected error comparing files %1 and %2:\n%3").
+                 arg(fname1).arg(fname2).arg(ex.toString().c_str()),
+            tr("&Continue"), QString::null,QString::null,
+            0, 1 );
+    }
+
+}
+
 void FWWindow::findExternalRefs(FWObject *lib,
                                        FWObject *root,
                                        list<FWReference*> &extRefs)
@@ -1820,10 +1979,10 @@
     if (visibleFirewall==fw)  visibleFirewall=NULL;
 }
 
-void FWWindow::setPolicyBranchTabName(PolicyRule *rule)
+void FWWindow::setPolicyBranchTabName(RuleSet *subset)
 {
-    RuleSet *subset = rule->getBranch();
-    assert(subset);
+    assert(subset!=NULL);
+    PolicyRule *rule = PolicyRule::cast(subset->getParent());
     RuleSetView *rsv = ruleSetViews[subset];
     assert(rsv);
     FWOptions *ropt = rule->getOptionsObject();
@@ -1831,8 +1990,11 @@
     ruleSets->changeTab(rsv, tr("Policy/%1").arg(branchName) );
 }
 
-void FWWindow::addPolicyBranchTab(PolicyRule *rule)
+void FWWindow::addPolicyBranchTab(RuleSet *subset)
 {
+    assert(subset!=NULL);
+
+    PolicyRule *rule = PolicyRule::cast(subset->getParent());
     FWOptions *ropt = rule->getOptionsObject();
     QString branchName = ropt->getStr("branch_name").c_str();
 
@@ -1841,33 +2003,30 @@
     QApplication::eventLoop()->processEvents(QEventLoop::ExcludeUserInput,1000);
     if (fwbdebug)  qDebug("FWWindow::reopenFirewall()   adding branch tab");
 
-    Policy *subset = Policy::cast(rule->getBranch());
-    if (subset==NULL)
-    {
-        subset = new Policy();
-        rule->add(subset);
-    }
+//    if (subset==NULL)
+//    {
+//        subset = new Policy();
+//        rule->add(subset);
+//    }
     if (ruleSetViews.count(subset)==0)
     {
-        RuleSetView *rsv;
-        ruleSets->addTab(rsv=new PolicyView(subset,NULL),
-                         "Branch"); // temporary name
+        RuleSetView *rsv = new PolicyView(Policy::cast(subset),NULL);
+        ruleSets->addTab(rsv,"Branch"); // temporary name
         ruleSetViews[subset]=rsv;
     }
-    setPolicyBranchTabName(rule);
+    setPolicyBranchTabName(subset);
 
     for (FWObject::iterator i=subset->begin(); i!=subset->end(); i++)
     {
         PolicyRule *srule = PolicyRule::cast(*i);
         if (srule->getAction() == PolicyRule::Branch)
-            addPolicyBranchTab(srule);
+            addPolicyBranchTab(srule->getBranch());
     }
 
 }
 
-void FWWindow::removePolicyBranchTab(PolicyRule *rule)
+void FWWindow::removePolicyBranchTab(RuleSet *subset)
 {
-    RuleSet *subset = rule->getBranch();
     if (subset==NULL) return;
     RuleSetView *rsv = ruleSetViews[subset];
     assert(rsv);
@@ -1877,8 +2036,11 @@
 
 void FWWindow::scheduleRuleSetRedraw()
 {
-    ruleSetRedrawPending = true;
-    QTimer::singleShot( 0, this, SLOT(redrawRuleSets()) );
+    if (!ruleSetRedrawPending)
+    {
+        ruleSetRedrawPending = true;
+        QTimer::singleShot( 0, this, SLOT(redrawRuleSets()) );
+    }
 }
 
 void FWWindow::redrawRuleSets()
@@ -1927,7 +2089,7 @@
     {
         PolicyRule *rule = PolicyRule::cast(*i);
         if (rule->getAction() == PolicyRule::Branch)
-            addPolicyBranchTab(rule);
+            addPolicyBranchTab(rule->getBranch());
     }
 
 // let the GUI process events to display new tab(s)
@@ -2424,7 +2586,7 @@
 void FWWindow::ruleSetTabChanged(QWidget* w)
 {
     if (fwbdebug)
-        qDebug("FWWindow::ruleSetTabChanged:  w=%x ruleSetTabIndex=%d changingTabs=%d",
+        qDebug("FWWindow::ruleSetTabChanged:  w=%p ruleSetTabIndex=%d changingTabs=%d",
                w,ruleSetTabIndex,changingTabs);
 
     if (changingTabs) return;
